const long SerSpeed=115200; //baud rate
const byte Tmr1Spd=0x01;    // Timer1 prescaler, changes PWM freq of pin 9,10

//********************** pin assignment ****************************************

#define faderA    0        // linear pot A (analog in)
#define ENA_pin   9        // Enable of H-bridge A
#define pin1A     8        // direction pin 1 of H-bridge A
#define pin2A     7        // direction pin 2 of H-bridge A
#define currA     2        // current sense of H-bridge A (analog in)

#define faderB    1        // linear pot B (analog in)
#define ENB_pin   10       // Enable of H-bridge B
#define pin1B     12       // direction pin 1 of H-bridge B
#define pin2B     13       // direction pin 2 of H-bridge B
#define currB     3        // current sense of H-bridge B (analog in)

#define potA      4        // rotary potmeter A (analog in)
#define debugPin  4        // for debugging

byte myID = '1';              // ID number of this Arduino
byte recID = '0';

boolean MaxComm = false;

unsigned int SetPoint = 0;
int SetPointPrev=0;

// ********************* variables related to fader and motor A
int faderAVal=0;        // Value read of fader A
int faderAValArray[]={
  0,0,0,0,0,0,0,0,0,0};
int prevFaderAVal;      // previously stored value read from fader A
int SetPointA;
int deltaA;
int faderAAvg;

int MASpeed=0;          // speed/power for motor A
boolean EnableMA=true;  // enable motor A, 1=on1
int MAState=0;          // 0=off, 1=down, 2=up
int MACurrent;

// ********************* variables related to fader and motor B
int faderBVal=0;        // Value read of fader B
int prevFaderBVal;      // previously stored value read from fader B
int faderBValArray[]={
  0,0,0,0,0,0,0,0,0,0}; // size of this array HAS TO BHE the same of faderAValArray, 
                        // otherwize unpredictable results
int SetPointB;
int deltaB;
int faderBAvg;

int MBSpeed=0;          // speed/power for motor B
boolean EnableMB=true;  // enable motor B, 1=on
int MBState=0;          // 0=off, 1=down, 2=up
int MBCurrent;

//***************** serial communication ******************

byte serInString[3];    // array to hold the serial input string
int serInIndx=0;
int serOutIndx=0;

//***************** time variables
long prevMillisA = 0; // will store last update time
long intervalA = 1;     //interval between steps

int slowUpdateStepSize = 1;

long prevMillisB = 0;
long timeout=1000;
 

// ********************* variables for PI(D)
int margin = 2;
float Kp = 8;
float Ki = 0;
float Kd = 4;
