
//**********************************************
// Slow SetPoint update (mostly to prevent oscillation when used with MAXMSP patch)
//**********************************************

 int slowSetPointUpdate(int newSetPoint){
 static int oldSetPoint;

if (millis()>prevMillisA+intervalA){
  
  if (oldSetPoint<newSetPoint){
    oldSetPoint=oldSetPoint+slowUpdateStepSize;
  }
  else if(oldSetPoint>newSetPoint){
  oldSetPoint=oldSetPoint-(slowUpdateStepSize);
  }
  else{
  oldSetPoint=newSetPoint;
  }
oldSetPoint=constrain(oldSetPoint, 0, 1023);
return oldSetPoint;

  prevMillisA=millis();
}

 }


//**********************************************
// if there is communication with maxmssp,
// the avarage is calculated over 3 values, otherwise over 2
//**********************************************

int calcSetPoint(int valA, int valB, int valC){
  int calc=0;
  if (MaxComm){
  calc=((valA+valB+valC)/3);
  }
  else{
  calc=((valB+valC)/2);
  }

  return slowSetPointUpdate(calc);
}


//**********************************************
// somehow the sample interval should be in the PID function,
// but isn't now, therefore the integration part doesn't work 
// quite like it should.
//**********************************************
int updatePIDA( int setPointVal, int currentVal){
  float output = 0;
  int error = 0;
  static int integral = 0;
  int derivative = 0;
  static int prev_error = 0;

  error = setPointVal - currentVal;
  if (abs(error)<= margin){
    error=0;
  }

  integral = integral + error;
  derivative = (error - prev_error);
  output = (Kp*error) + (Ki*integral) + (Kd*derivative);
  prev_error = error;
  return constrain (int(output), -255, 255);
}

//**********************************************
int updatePIDB( int setPointValB, int currentValB){
  float outputB = 0;
  int errorB = 0;
  static int integralB = 0;
  int derivativeB = 0;
  static int prev_errorB = 0;

  errorB = setPointValB - currentValB;
  if (abs(errorB)<= margin){
    errorB=0;
  }

  integralB = integralB + errorB;
  derivativeB = (errorB - prev_errorB);
  outputB = (Kp*errorB) + (Ki*integralB) + (Kd*derivativeB);
  prev_errorB = errorB;
  return constrain (int(outputB), -255, 255);
}

//************************************************
void readSerialString() {
  byte sb;
  if (millis()>prevMillisB+timeout){
    MaxComm=false;
  }
  else{
    if(Serial.available()) {
      sb = Serial.read();
      if (sb=='#'){
        while (Serial.available() && serInIndx<=sizeof(serInIndx)){
          sb = Serial.read();          
          serInString[serInIndx] = sb;
          serInIndx++;
        }
        recID=serInString[0];
        SetPoint=serInString[1]<<8 | serInString[2];
        /*  
         Serial.print("SetPoint = ");
         Serial.println(SetPoint);
         */
        serInIndx = 0;   
        MaxComm=true;
        prevMillisB=millis();
      }
    }
  }
}

//************************************************
void   serialRespond(){

  switch (recID){
  case '0':
    break;
  case '1':
    Serial.print(recID);
    Serial.print(" ");
    Serial.print(calcSetPoint(SetPoint, faderAVal, faderBVal));
    Serial.print(" ");
    Serial.println(faderAVal);
    recID='0';
    break;
  case '2':
    Serial.print(recID);
    Serial.print(" ");
    Serial.print(calcSetPoint(SetPoint, faderAVal, faderBVal));
    Serial.print(" ");
    Serial.println(faderBVal);
    recID='0';
    break;
  default:
    recID='0';
    break;
  }
  /*
  if(recID==myID){
   Serial.print(SetPoint);
   Serial.print(" ");
   Serial.println(faderAVal);
   recID='0';
   }
   */


}

//************************************************


//************************************************
void printSerialString() {
  if( serInIndx > 0) {
    Serial.print("Echo: ");
    //loop through all bytes in the array and print them out
    for(serOutIndx=0; serOutIndx <sizeof(serInString); serOutIndx++) {
      Serial.print( serInString[serOutIndx] ); //print out the byte at the specified index
      //serInString[serOutIndx] = ""; //optional: flush out the content
    }
    //reset all the functions to be able to fill the string back with content
    serOutIndx = 0;
    serInIndx = 0;
    Serial.println();
  }
}



